#ifndef OPTH
#define OPTH

#include <stack>
#include "../../IR/llvm.h"
#include "judge.h"

typedef Value* valptr;
typedef BasicBlock* BBptr;
typedef Function*  Fptr;

class nodule {
public:
  BBptr bb;
  std::set<nodule *> pre;
  std::set<nodule *> suc;
  int  d_num, low;
  bool inStack;
  nodule(BBptr init_b, int init_d, int init_l, bool init_I) : bb(init_b),  d_num(init_d), low(init_l), inStack(init_I) {}
  ~nodule() = default;
};

class DTree {
  std::vector<BBptr > rPostTraverse;
  std::map<BBptr , int> TInd;
  std::vector<BBptr > doBBs;
  std::vector<Fptr> func_list ;
  std::map<BBptr , int> rTInd;
  std::vector<BBptr > rDomainBlock;
  std::vector<BBptr > rTraverse;
  BBptr BB_exit;
public:
  Module *m;
  DTree(Module *init_m) : m(init_m) {func_list = m->function_list_;}
  void implement();
  bool getPostRraverse(Fptr );
  std::vector<BBptr > postTraverse(BBptr  );
  void Blockdom(Fptr );
  void BlockFront(Fptr );
  BBptr compare_judge(BBptr  , BBptr  );
  void rDTree();
  void getPostRraverse_2(Fptr );
  void getDomR(Fptr );
  void getRDom(Fptr );
  void FrontR(Fptr );
  bool TraversePost(BBptr  , std::set<BBptr > &);
};


class SJump {

public:
  Module *m;
  std::vector<Fptr> func_list;
  SJump(Module *init_m) : m(init_m) {func_list = m->function_list_;}
  void implement();
  void deleteUselessBlock(Fptr , std::vector<BBptr > &uselessBlock);
  bool checkUselessJump(BBptr  );
  void solvePHI(Fptr );
  void solveJUMP(Fptr );
  void mergeBBs(Fptr );
  void solveunREACH(Fptr );
};




 class CInstr {
 public:
    Module *m;
    std::map<valptr, ConstantInt *> val_constant;
    std::map<valptr, ConstantFloat *> val_float;
    std::map<Instruction *, BBptr > uselessInstr;
    std::vector<Fptr> func_list;
    CInstr(Module *init_m) : m(init_m) {func_list = m->function_list_;}
    bool forwardconst(Fptr );
    bool solveBranch(Fptr );
    void implement();
    void checkBBs(BBptr  );
 };



class DCodeSolve  {
private:
  std::set<std::string> OptFunc;
  std::map<Fptr, std::set<valptr>> funcPtrArgs;
  std::vector<Fptr> func_list;
  std::map<valptr, std::vector<valptr>> storePos;
  BBptr BB_exit;
  std::set<Instruction *> uselessInstr;
  std::set<BBptr > uselessBlock;

public:
  Module *m;
  DCodeSolve(Module * init_m) : m(init_m), BB_exit(nullptr) {
    OptFunc = {"getint", "getfloat", "getch", "getarray","getfarray", "putint","putfloat", "putch","putarray","putfarray","_sysy_starttime", "_sysy_stoptime","memcpy","memclr",
                                  "memset","llvm.memset.p0.i32","__aeabi_memcpy4", "__aeabi_memclr4","__aeabi_memset4"
  };
  func_list = m->function_list_;
  }
  void implement();
  void initFuncPtrArg();
  void Init(Fptr );
  bool checkOpt(Fptr , Instruction *instr);
  void findInstr(Fptr );
  void deleteInstr(Fptr );
};



class LInvariant  {
 int ind;
  std::stack<nodule *> store_tj;
  std::stack<std::set<BBptr > *> store_loop;
  std::map<std::set<BBptr > *, BBptr > enterptr;
  std::vector<Fptr> func_list;
 public:
   Module *m;
   LInvariant(Module * init_m)  : m(init_m) {func_list = m->function_list_;}
  void implement();
   void searchLoop();
  bool searchC(std::set<nodule *> & , std::set<std::set<nodule *> *> & );
   void tj(nodule * , std::set<std::set<nodule *> *> & );
};


#endif 
