#include "build.h"


LIRIntInst* CreateStmt::create_lirinst(LIRInstruction::LIRInstTy id, LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1, LIROperand* v2) {
        return new LIRIntInst(id, cond_id, result, v1, v2, this->BB_);
}

LIRIntInst* CreateStmt::create_lirinst(LIRInstruction::LIRInstTy id, LIRInstruction::LIRCondTy cond_id, LIROperand* result, 
                                    LIROperand* v1, LIROperand* v2, LIROperand* v3) {
    return new LIRIntInst(id, cond_id, result, v1, v2,v3, this->BB_); 
}

LIRFloatInst* CreateStmt::create_lirfinst(LIRInstruction::LIRInstTy id, LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1, LIROperand* v2) {
    return new LIRFloatInst(id, cond_id, result, v1, v2, this->BB_);
}

LIRFloatInst* CreateStmt::create_lirfinst(LIRInstruction::LIRInstTy id, LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1) {
    return new LIRFloatInst(id, cond_id, result, v1, this->BB_);
}
LIRIntInst* CreateStmt::create_cmp(LIRInstruction::LIRCondTy cond_id, LIROperand* v1, LIROperand* v2) { 
    return new LIRIntInst(LIRInstruction::LCmpTy, cond_id, nullptr, v1, v2, this->BB_); 
}
LIRFloatInst* CreateStmt::create_vcmp(LIRInstruction::LIRCondTy cond_id, LIROperand* v1, LIROperand* v2) {
     return new LIRFloatInst(LIRInstruction::LVcmpTy, cond_id, nullptr, v1, v2, this->BB_); 
}
LIRVmrsInst* CreateStmt::create_vmrs() { return new LIRVmrsInst(this->BB_); }
LIRMovInst* CreateStmt::create_mov(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1) {
     return new LIRMovInst(cond_id, result,v1, this->BB_); 
}
LIRVmovInst* CreateStmt::create_vmov(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1) {
     return new LIRVmovInst(cond_id, result,v1, this->BB_); 
}
LIRVmovf32Inst* CreateStmt::create_vmovf32(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1) {
     return new LIRVmovf32Inst(cond_id, result,v1, this->BB_); 
}
LIRMov32Inst* CreateStmt::create_mov32(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIRConstant* v1) {
     return new LIRMov32Inst(cond_id, result,v1, this->BB_); 
}
LIRMov32Inst* CreateStmt::create_mov32(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIRFunction* v1) {
     return new LIRMov32Inst(cond_id, result,v1, this->BB_); 
}
LIRMov32Inst* CreateStmt::create_mov32(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIRGlobalVariable* v1) {
     return new LIRMov32Inst(cond_id, result,v1, this->BB_); 
}
LIRLdrInst* CreateStmt::create_ldr(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1, LIROperand* v2, LIRInstruction::LIRAddrTy addr_tid) {
     return new LIRLdrInst(cond_id, result,v1, v2,addr_tid, this->BB_); 
}
LIRVldrInst* CreateStmt::create_vldr(LIRInstruction::LIRCondTy cond_id, LIROperand* result, LIROperand* v1, LIROperand* v2) {
     return new LIRVldrInst(cond_id, result,v1, v2, this->BB_); 
     
}
LIRStrInst* CreateStmt::create_str(LIRInstruction::LIRCondTy cond_id, LIROperand* v1, LIROperand* v2, LIROperand* v3, LIRInstruction::LIRAddrTy addr_tid) {
     return new LIRStrInst(cond_id, v1,v2,v3,addr_tid, this->BB_); 
}
LIRVstrInst* CreateStmt::create_vstr(LIRInstruction::LIRCondTy cond_id, LIROperand* v1, LIROperand* v2, LIROperand* v3) {
     return new LIRVstrInst(cond_id, v1,v2,v3, this->BB_); 
}
LIRBInst* CreateStmt::create_b(LIRInstruction::LIRCondTy cond_id, LIRBasicBlock* target_bb){return new LIRBInst(cond_id,target_bb,this->BB_);}
LIRBlInst* CreateStmt::create_bl(LIRInstruction::LIRCondTy cond_id, LIRFunction* target_func,bool result_unused){
    return new LIRBlInst(cond_id,target_func,result_unused,this->BB_);
}
LIRPushInst *CreateStmt::create_push(LIRInstruction::LIRCondTy cond_id, const std::vector<LIROperand *> &reglist) {
    return new LIRPushInst(cond_id,reglist,this->BB_);
}
LIRPopInst *CreateStmt::create_pop(LIRInstruction::LIRCondTy cond_id, const std::vector<LIROperand *> &reglist) {
    return new LIRPopInst(cond_id,reglist,this->BB_);
}