#include "build.h"
void CreateStmt::remove_redundant_load_store() {
    for (LIRFunction* lirf : m_lir->function_list_) {
        for (LIRBasicBlock* lirbb : lirf->basic_blocks_) {
            std::map<LIRInstruction*, LIRInstruction*> replaceinst_map;
            for (auto iter = lirbb->instr_list_.begin(); iter != std::prev(lirbb->instr_list_.end()); iter++) {
                LIRInstruction* lirinst = *iter;
                if (lirinst->op_id_ == LIRInstruction::LStrTy) {
                    LIROperand* rx = lirinst->get_operand(0);
                    LIROperand* rb = lirinst->get_operand(1);
                    LIROperand* cz = lirinst->get_operand(2);
                    auto it2 = iter;
                    it2 = std::next(it2);
                    while (it2 != lirbb->instr_list_.end() &&
                    !((*it2)->op_id_ == LIRInstruction::LBlTy) &&
                    (*it2)->result_ != rx &&
                    (*it2)->result_ != rb &&
                    !((*it2)->op_id_ == LIRInstruction::LStrTy && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz) &&
                    !((*it2)->op_id_ == LIRInstruction::LVstrTy && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz)) {
                        LIRInstruction* nextinst = *it2;
                        if (nextinst->op_id_ == LIRInstruction::LLdrTy && nextinst->get_operand(0) == rb && nextinst->get_operand(1) == cz) {
                            LIROperand* ry = nextinst->result_;
                            if (ry == rx) {
                                
                                replaceinst_map[nextinst] = nullptr;
                            } else {
                               
                                replaceinst_map[nextinst] = new LIRMovInst(LIRInstruction::LCondNone, ry, rx);
                            }
                        } else if (nextinst->op_id_ == LIRInstruction::LVldrTy && nextinst->get_operand(0) == rb && nextinst->get_operand(1) == cz) {
                            
                            LIROperand* sy = nextinst->result_;
                            replaceinst_map[nextinst] = new LIRVmovInst(LIRInstruction::LCondNone, sy, rx);
                        }
                        it2 = std::next(it2);
                    }
                }else if (lirinst->op_id_ == LIRInstruction::LVstrTy) {
                   
                    LIROperand* sx = lirinst->get_operand(0);
                    LIROperand* rb = lirinst->get_operand(1);
                    LIROperand* cz = lirinst->get_operand(2);
                    auto it2 = iter;
                    it2 = std::next(it2);
                    while (it2 != lirbb->instr_list_.end() &&
                    !((*it2)->op_id_ == LIRInstruction::LBlTy) &&
                    (*it2)->result_ != sx &&
                    (*it2)->result_ != rb &&
                    !((*it2)->op_id_ == LIRInstruction::LStrTy && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz) &&
                    !((*it2)->op_id_ == LIRInstruction::LVstrTy && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz)) {
                        LIRInstruction* nextinst = *it2;
                        if (nextinst->op_id_ == LIRInstruction::LLdrTy && nextinst->get_operand(0) == rb && nextinst->get_operand(1) == cz) {
                           
                            LIROperand* ry = nextinst->result_;
                            replaceinst_map[nextinst] = new LIRVmovInst(LIRInstruction::LCondNone, ry, sx);
                        } else if (nextinst->op_id_ == LIRInstruction::LVldrTy && nextinst->get_operand(0) == rb && nextinst->get_operand(1) == cz) {
                            LIROperand* sy = nextinst->result_;
                            if (sy == sx) {
                                replaceinst_map[nextinst] = nullptr;
                            } else {
                              
                                replaceinst_map[nextinst] = new LIRVmovf32Inst(LIRInstruction::LCondNone, sy, sx);
                            }
                        }
                        it2 = std::next(it2);
                    }
                } else if (lirinst->op_id_ == LIRInstruction::LLdrTy) {
                 
                    LIROperand* rx = lirinst->result_;
                    LIROperand* rb = lirinst->get_operand(0);
                    LIROperand* cz = lirinst->get_operand(1);
                    auto it2 = iter;
                    it2 = std::next(it2);
                    while (it2 != lirbb->instr_list_.end() &&
                    !((*it2)->op_id_ == LIRInstruction::LBlTy) &&
                    (*it2)->result_ != rx &&
                    (*it2)->result_ != rb &&
                    !((*it2)->op_id_ == LIRInstruction::LStrTy && (*it2)->get_operand(0) != rx && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz) &&
                    !((*it2)->op_id_ == LIRInstruction::LVstrTy && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz)) {
                        LIRInstruction* nextinst = *it2;
                        if (nextinst->op_id_ == LIRInstruction::LStrTy && nextinst->get_operand(0) == rx && nextinst->get_operand(1) == rb && nextinst->get_operand(2) == cz) {
                            
                            replaceinst_map[nextinst] = nullptr;
                        }
                        it2 = std::next(it2);
                    }
                } else if (lirinst->op_id_ == LIRInstruction::LVldrTy) {
                  
                    LIROperand* sx = lirinst->result_;
                    LIROperand* rb = lirinst->get_operand(0);
                    LIROperand* cz = lirinst->get_operand(1);
                    auto it2 = iter;
                    it2 = std::next(it2);
                    while (it2 != std::prev(lirbb->instr_list_.end()) &&
                    !((*it2)->op_id_ == LIRInstruction::LBlTy) &&
                    (*it2)->result_ != sx &&
                    (*it2)->result_ != rb &&
                    !((*it2)->op_id_ == LIRInstruction::LStrTy && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz) &&
                    !((*it2)->op_id_ == LIRInstruction::LVstrTy && (*it2)->get_operand(0) != sx && (*it2)->get_operand(1) == rb && (*it2)->get_operand(2) == cz)) {
                        LIRInstruction* nextinst = *it2;
                        if (nextinst->op_id_ == LIRInstruction::LVstrTy && nextinst->get_operand(0) == sx && nextinst->get_operand(1) == rb && nextinst->get_operand(2) == cz) {
                            replaceinst_map[nextinst] = nullptr;
                        }
                        it2 = std::next(it2);
                    }
                }
            }
           
            for (const auto& pair : replaceinst_map) {
                if (pair.second == nullptr) {
                    lirbb->delete_instr(pair.first);
                } else {
                    lirbb->replace_instr(pair.first, pair.second);
                }
            }
        }
    }
}

void CreateStmt::remove_useless_insts() {
    for (LIRFunction* lirf : m_lir->function_list_) {
        std::set<LIROperand*> useStatus;
        if (lirf->has_result_ == 1) {
          
            useStatus.insert(m_lir->get_LIRPhysReg(1));
        } else if (lirf->has_result_ == 2) {
            
            useStatus.insert(m_lir->get_LIRPhysFReg(-1));
        }
       
        for (LIRBasicBlock* lirbb : lirf->basic_blocks_) {
            for (LIRInstruction* lirinst : lirbb->instr_list_) {
                if (lirinst->op_id_ == LIRInstruction::LBlTy) {
                    LIRFunction* calllirf = static_cast<LIRFunction*>(lirinst->get_operand(0));
                    if (calllirf->name_ == "malloc") {
                        
                        useStatus.insert(m_lir->get_LIRPhysReg(1));
                    } else {
                        for (int i = 0; i < calllirf->num_args_; i++) {
                            LIROperand* apm = calllirf->args_passmethod_[i];
                            if (apm != nullptr) {
                                useStatus.insert(apm);
                            }
                        }
                    }
                    continue;
                }
                for (LIROperand* lirop : lirinst->operands_) {
                    if (lirop->tid_ == LIROperand::LOVirtRegTy || lirop->tid_ == LIROperand::LOVirtFRegTy || lirop->tid_ == LIROperand::LOPhysRegTy || lirop->tid_ == LIROperand::LOPhysFRegTy) {
                        useStatus.insert(lirop);
                    }
                }
            }
        }
     
        for (LIRBasicBlock* lirbb : lirf->basic_blocks_) {
            std::list<LIRInstruction*> insts_to_delete;
            for (LIRInstruction* lirinst : lirbb->instr_list_) {
                if (lirinst->result_ != nullptr) {
                    if (!useStatus.count(lirinst->result_)) {
                        insts_to_delete.push_back(lirinst);
                        continue;
                    }
                }
                if (lirinst->op_id_ == LIRInstruction::LMovTy) {
                    if (lirinst->get_operand(0) == lirinst->result_) {
                        insts_to_delete.push_back(lirinst);
                        continue;
                    }
                }
                if (lirinst->op_id_ == LIRInstruction::LVmovf32Ty) {
                    if (lirinst->get_operand(0) == lirinst->result_) {
                        insts_to_delete.push_back(lirinst);
                        continue;
                    }
                }
                if (lirinst->op_id_ == LIRInstruction::LAddTy || lirinst->op_id_ == LIRInstruction::LSubTy) {
                    if (lirinst->get_operand(0) == lirinst->result_ && lirinst->get_operand(1) == m_lir->get_LIRConstant(0)) {
                        insts_to_delete.push_back(lirinst);
                        continue;
                    }
                }
            }
            for (LIRInstruction* lirinst : insts_to_delete) {
                lirbb->delete_instr(lirinst);
            }
        }
    }
}
