#include "register.h"


int Register::getReg(LIROperand* opnd, LIRInstruction* inst) {
    if(is_o2_){
        if(!inst){
            return 0;
        }
        if(!opnd){
            return 0;
        }
        if( !isRelevant(opnd,inst)){
            return 0;
        }
        Pii* itv = opnd_inst_in_itv[opnd][inst];
        if(!itv){
            return 0;
        }else{
            if(final_result_.count(itv)==0){
                return 0;
            }else if(final_result_[itv]==0){
                return 0;
            }
            return final_result_[itv];
        }
    }else{
        return REGALLOC_SPILL;
    }
}

void Register::run() {
    if(lirf_ && lirm_){
        if(is_o2_){
           
            assignForFunc();
        }
        process_code();
    }else {
        if(!lirf_){
        }
        if(!lirm_){
        }
    }
}

void Register::assignForFunc() {
    preF();
    computeBlockOrder();
    live_analyse();
    linearScan();
}
void Register::live_analyse() {
    live_analyse_1();
    if(!retBB){
    }
    else if(retBB!=basicBlocksOrder.back()){
    }
    live_analyse_2();
    live_analyse_3();
}
void Register::live_analyse_1() {
    unsigned int inst_idx = INST_GAP;
    for (std::vector<LIRBasicBlock *>::iterator iter2 = basicBlocksOrder.begin(); iter2 != basicBlocksOrder.end(); iter2++) {
        LIRBasicBlock *bb = *iter2;
        bool isFirstInst = true;
        std::unordered_map<LIROperand*,unsigned int> phys_reg_mark;
        LIRInstruction *last_inst = nullptr, *llast_inst = nullptr;
        for (std::list<LIRInstruction*>::iterator iter3 = bb->instr_list_.begin(); iter3 != bb->instr_list_.end(); inst_idx+=INST_GAP,iter3++) {
            LIRInstruction *inst = *iter3;
            instIdx[inst] = inst_idx;
            idxInst[inst_idx] = inst;
            if (isFirstInst) {
                isFirstInst = false;
                bbInterval[bb].first = inst_idx;
            }
            if(inst->op_id_ == LIRInstruction::LBlTy){
                LIRFunction* func_opnd = dynamic_cast<LIRFunction*>(inst->get_operand(0));
                if(!func_opnd){
                }
                for(auto & it : phys_reg_mark){
                    addIntervalAtBack_positive(it.first, it.second, inst_idx);
                }
                phys_reg_mark.clear();
                int cond = is_KF_hasR_noUse(inst);
                if(cond!=0){
                    addIntervalAtBack_positive(cond, inst_idx);
                }
            }
            for (LIROperand *opnd: inst->operands_) {
                if(opnd->tid_==LIROperand::LOVirtRegTy){
                    if (live_def[bb].count(opnd) == 0) {
                        live_use[bb].emplace_back(opnd);
                    }
                }
                else if(opnd->tid_==LIROperand::LOVirtFRegTy){
                    if (live_def[bb].count(opnd) == 0) {
                        live_use[bb].emplace_back(opnd);
                    }
                }
                else if(opnd->tid_==LIROperand::LOPhysRegTy && dynamic_cast<LIRPhysReg*>(opnd)->rid_ <= TOP_LIMIT_PHYS_REG){
                    if(bb==initBB){
                        addIntervalAtBack_positive(opnd, bbInterval[initBB].first, inst_idx);
                    }
                    else {
                        int rid = dynamic_cast<LIRPhysReg*>(opnd)->rid_;
                        std::list<Pii> &intervals_physreg = intervals_token_phys_reg[rid];
                        if(rid == 1){
                            if(last_inst && last_inst->op_id_ == LIRInstruction::LBlTy && dynamic_cast<LIRFunction*>(last_inst->get_operand(0))->has_result_==1){
                                addIntervalAtBack_positive(opnd, inst_idx - INST_GAP, inst_idx);
                            }else if(llast_inst && llast_inst->op_id_ == LIRInstruction::LBlTy && dynamic_cast<LIRFunction*>(llast_inst->get_operand(0))->has_result_==1){
                                addIntervalAtBack_positive(opnd, inst_idx - INST_GAP-INST_GAP, inst_idx);
                            }else{
                            }
                        }else{
                        }
                    }
                }
                else if(opnd->tid_==LIROperand::LOPhysFRegTy && dynamic_cast<LIRPhysFReg*>(opnd)->frid_ >= BOTTOM_LIMIT_PHYS_FREG){
                    if(bb==initBB){
                        addIntervalAtBack_positive(opnd, bbInterval[initBB].first, inst_idx);
                    }
                    else{
                        int frid = dynamic_cast<LIRPhysFReg*>(opnd)->frid_;
                        std::list<Pii> &intervals_physreg = intervals_token_phys_reg[frid];
                        if(frid == -1){
                            if( last_inst && last_inst->op_id_ == LIRInstruction::LBlTy && dynamic_cast<LIRFunction*>(last_inst->get_operand(0))->has_result_==2){
                                addIntervalAtBack_positive(opnd, inst_idx - INST_GAP, inst_idx);
                            }else if( llast_inst && llast_inst->op_id_ == LIRInstruction::LBlTy && dynamic_cast<LIRFunction*>(llast_inst->get_operand(0))->has_result_==2){
                                addIntervalAtBack_positive(opnd, inst_idx - INST_GAP - INST_GAP, inst_idx);
                            }else{
                            }
                        }else{
                        }
                    }
                }
            }
            if(inst->result_){
                LIROperand * def_opnd = inst->result_;
                if(def_opnd->tid_ == LIROperand::LOPhysRegTy && dynamic_cast<LIRPhysReg*>(def_opnd)->rid_ <= TOP_LIMIT_PHYS_REG){
                    if(phys_reg_mark.count(def_opnd) != 0){
                    }
                    phys_reg_mark[def_opnd] = inst_idx;
                }
                else if(def_opnd->tid_ == LIROperand::LOPhysFRegTy && dynamic_cast<LIRPhysFReg*>(def_opnd)->frid_ >= BOTTOM_LIMIT_PHYS_FREG){
                    if(phys_reg_mark.count(def_opnd) != 0){
                    }
                    phys_reg_mark[def_opnd] = inst_idx;
                }else if(def_opnd->tid_==LIROperand::LOVirtRegTy || def_opnd->tid_==LIROperand::LOVirtFRegTy){
                    live_def[bb].emplace(def_opnd);
                }
            }
            llast_inst = last_inst;
            last_inst = inst;
        }
        if(bb==retBB && isFirstInst ) {
            bbInterval[bb].first = inst_idx;
            bbInterval[bb].second = inst_idx;
        }
        else if(bb==initBB && isFirstInst){
            bbInterval[bb].first = 0;
            bbInterval[bb].second = 0;
        }
        else{
            bbInterval[bb].second = inst_idx - INST_GAP;
        }
        live_in[bb] = std::vector< LIROperand*>(live_use[bb].begin(), live_use[bb].end());
        if(!phys_reg_mark.empty()){
            if(bb==retBB && phys_reg_mark.size()==1){
                auto it = phys_reg_mark.begin();
                addIntervalAtBack_positive(it->first, it->second, bbInterval[retBB].second);
            }else if(bb!=retBB){
            }else{
            }
        }
    }
}
void Register::live_analyse_2() {
    bool change = true;
    while (change) {
        change = false;
        for (std::vector<LIRBasicBlock*>::reverse_iterator iter2 = basicBlocksOrder.rbegin(); iter2 != basicBlocksOrder.rend(); iter2++) {
            LIRBasicBlock* bb = *iter2;
            std::vector< LIROperand*> new_out;
            std::vector< LIRBasicBlock*> sbb_vec = bb->succ_bbs_;
            if (!sbb_vec.empty()) {
                for ( LIRBasicBlock* sbb_ptr : sbb_vec) {
                    std::vector< LIROperand*> temp;
                    temp.resize(live_in[sbb_ptr].size()+new_out.size());
                    std::sort(live_in[sbb_ptr].begin(), live_in[sbb_ptr].end());
                    auto temp_end = std::set_union(live_in[sbb_ptr].begin(), live_in[sbb_ptr].end(), new_out.begin(), new_out.end(), temp.begin());
                    new_out = std::vector< LIROperand*>(temp.begin(), temp_end);
                }
            }
            if (new_out != live_out[bb]) {
                change = true;
                live_out[bb] = new_out;
                std::vector< LIROperand*> diff, uni;
                diff.resize(live_out[bb].size());
                std::sort(live_out[bb].begin(), live_out[bb].end());
                auto diff_end = std::set_difference(live_out[bb].begin(), live_out[bb].end(), live_def[bb].begin(), live_def[bb].end(), diff.begin());
                diff.resize(diff_end-diff.begin());
                uni.resize(diff.size()+live_use[bb].size());
                std::sort(live_use[bb].begin(), live_use[bb].end());
                std::sort(diff.begin(), diff.end());
                auto uni_end = std::set_union(live_use[bb].begin(), live_use[bb].end(), diff.begin(), diff.end(), uni.begin());
                live_in[bb].assign(uni.begin(), uni_end);
            }
        }
    }
}
void Register::live_analyse_3() {
    for (std::vector<LIRBasicBlock *>::reverse_iterator iter2 = basicBlocksOrder.rbegin(); iter2 != basicBlocksOrder.rend(); iter2++) {
        LIRBasicBlock *bb = *iter2;
        std::vector<LIROperand *> &live_out_bb = live_out[bb];
        std::set<LIROperand*> live_out_set = std::set<LIROperand*>(live_out_bb.begin(),live_out_bb.end());
        unsigned int bb_begin = bbInterval[bb].first;
        unsigned int bb_end = bbInterval[bb].second;
        for (LIROperand *opnd : live_out_set) {
            addInterval(opnd, bb_begin, bb_end, true);
        }
        LIRInstruction *last_inst = nullptr;
        for (std::list<LIRInstruction *>::iterator iter3 = bb->instr_list_.end(); iter3 != bb->instr_list_.begin(); ) {
            LIRInstruction *inst = *(--iter3);
            unsigned int now_idx = getInstIdx(inst);
            LIROperand *def_var = inst->result_;
            if (def_var != nullptr && (def_var->tid_==LIROperand::LOVirtRegTy || def_var->tid_==LIROperand::LOVirtFRegTy)) {
                opnd_inst_in_itv[def_var][inst] = cutInterval(def_var, now_idx,inst,last_inst);
            }
            for (LIROperand *opnd: inst->operands_) {
                if(opnd->tid_==LIROperand::LOVirtRegTy || opnd->tid_==LIROperand::LOVirtFRegTy){
                    opnd_inst_in_itv[opnd][inst]= addInterval(opnd, bb_begin, now_idx, false);
                }
            }
            last_inst = inst;
        }
    }
}
void Register::preF() {
    for(LIRBasicBlock* bb:lirf_->basic_blocks_){
        FEdge[bb] = bb->pre_bbs_.size();
    }
}
void Register::computeBlockOrder() {
    struct WorkListElem {
        LIRBasicBlock *bb;
        bool operator<(const WorkListElem &rhs) const {
            return bb->getLoopDepth() < rhs.bb->getLoopDepth();
        }
        explicit WorkListElem(LIRBasicBlock *b) : bb(b) {}
    };
    std::priority_queue<WorkListElem> work_list;
    initBB = lirf_->basic_blocks_[0];
    work_list.emplace(initBB);
    while(!work_list.empty()){
        LIRBasicBlock* bb = work_list.top().bb;
        work_list.pop();
        basicBlocksOrder.emplace_back(bb);
        basicBlocksOrderSet.emplace(bb);
        findRetBB(bb);
        for(auto nextBB:bb->succ_bbs_){
            if(basicBlocksOrderSet.count(nextBB)!=0) continue;
            nextBB->decreaseForwardBranches();
            if (nextBB->isForwardBranchesEQZero()) {
                work_list.emplace(nextBB);
            }
        }
    }
    if(lirf_->basic_blocks_.size()!=basicBlocksOrderSet.size()){
        LIRBasicBlock* dbgBB = nullptr;
        for(auto bbb : lirf_->basic_blocks_){
            if(basicBlocksOrderSet.count(bbb)==0){
                dbgBB = bbb;
            }
        }
    }
}
void Register::dfs(LIRBasicBlock *bb) {
    basicBlocksOrder.emplace_back(bb);
    basicBlocksOrderSet.emplace(bb);
    for(auto nextBB:bb->succ_bbs_){
        if(basicBlocksOrderSet.count(nextBB)!=0) continue;
        dfs(nextBB);
    }
}

void Register::addIntervalAtBack_positive(LIROperand *phy_reg, unsigned int begin, unsigned int end) {
    int rid;
    if(phy_reg->tid_==LIROperand::LOPhysRegTy){
        rid = dynamic_cast<LIRPhysReg*>(phy_reg)->rid_;
    }else if (phy_reg->tid_==LIROperand::LOPhysFRegTy){
        rid = dynamic_cast<LIRPhysFReg*>(phy_reg)->frid_;
    } else{
    }
    std::list<Pii> &intervals_physreg = intervals_token_phys_reg[rid];
    if(!intervals_physreg.empty()){
        Pii &last_interval = intervals_physreg.back();
        if(last_interval.second == begin){
            last_interval.second = end;
        }
        else if(last_interval.second < begin){
            intervals_physreg.emplace_back(begin,end);
        }else{
        }
    } else {
        intervals_physreg.emplace_back(begin,end);
    }
}

void Register::addIntervalAtBack_positive(int cond, unsigned int inst_idx){
    std::list<Pii> &intervals_physreg = intervals_token_phys_reg[cond];
    intervals_physreg.emplace_back(inst_idx,inst_idx);
}

Pii* Register::addInterval(LIROperand *opnd, unsigned int begin, unsigned int end, bool bb_range) {
    Var_live_intervals& intervals_vector = intervals[opnd];
    if(!intervals_vector.empty()){
        Pii& last_interval = intervals_vector.back();
        if(begin<last_interval.first){
            last_interval.first = begin;
        }
        if(last_interval.second<end){
            last_interval.second = end;
        }
    }else{
        intervals_vector.push_back(Pii(begin,end));
    }
    return &(intervals_vector.back());
}

Pii* Register::cutInterval(LIROperand *var_ptr, unsigned int cut_point, LIRInstruction* inst , LIRInstruction* last_inst) {
  
    Var_live_intervals& intervals_vector = intervals[var_ptr];

    if(!intervals_vector.empty()){
        Pii& last_interval = intervals_vector.back();
        if (last_interval.first <= cut_point && cut_point <= last_interval.second) {
            last_interval.first = cut_point;
            return &last_interval;
        }else if(cut_point<last_interval.first){
            last_interval.first = cut_point;
            return &last_interval;
        }else{
            last_interval.first = bbInterval[inst->parent_].second;
            return &last_interval;
        }
    }else{
        intervals_vector.push_back(bbInterval[inst->parent_]);
    }
    return &(intervals_vector.back());
}
void Register::linearScan() {
    for (std::pair< LIROperand* const, Var_live_intervals>& var_intervals_pair : intervals) {
        LIROperand* opnd = var_intervals_pair.first;
        Var_live_intervals& intervals_vec = var_intervals_pair.second;
        for (Pii& interval : intervals_vec) {
            all_intervals.emplace_back(&interval);
            interval_belong_umap[&interval] = opnd;
        }
    }
    std::sort(all_intervals.begin(), all_intervals.end(),
              [](Pii* a, Pii* b) { return a->first < b->first; });
    final_result_[&func_end] = REGALLOC_DEF_NO_USE;
    std::set< std::pair<Pii*, LIROperand*>, OpPtr> common_active;
    std::unordered_map<int, int> common_phys_regs;
    unsigned int common_phys_regs_freenum = 0;
    std::set< std::pair<Pii*, LIROperand*>, OpPtr> float_active;
    std::unordered_map<int, int> float_phys_regs;
    unsigned int float_phys_regs_freenum = 0;
    for (int i = 1; i <= TOP_LIMIT_PHYS_REG ; i++){
        common_phys_regs[i] = 1;
        common_phys_regs_freenum++;
    }
    for (int i = -1; i >= BOTTOM_LIMIT_PHYS_FREG ; i--){
        float_phys_regs[i] = 1;
        float_phys_regs_freenum++;
    }
    for (Pii* i : all_intervals) {
        LIROperand* i_var = interval_belong_umap[i];
        releaseOverdueIntervals(common_active,common_phys_regs,common_phys_regs_freenum,i,false);
        releaseOverdueIntervals(float_active,float_phys_regs,float_phys_regs_freenum,i,true);
        if(i_var->tid_ == LIROperand::LOVirtRegTy){
            assginFreeReg(common_active,common_phys_regs,common_phys_regs_freenum,i,false);
        }else if(i_var->tid_ == LIROperand::LOVirtFRegTy){
            assginFreeReg(float_active,float_phys_regs,float_phys_regs_freenum,i,true);
        }else{
        }
    }
    releaseOverdueIntervals(common_active,common_phys_regs,common_phys_regs_freenum,&func_end,false);
    releaseOverdueIntervals(float_active,float_phys_regs,float_phys_regs_freenum,&func_end,true);
    if(float_phys_regs_freenum!=PHYS_FREG_NUM){
    }
    if(common_phys_regs_freenum!=PHYS_REG_NUM){
    }
}
void Register::releaseOverdueIntervals(std::set<std::pair<Pii *, LIROperand *>, OpPtr> &common_active,
                                       std::unordered_map<int, int> &common_phys_regs, unsigned int &num, Pii* now_interval, bool isf) {
    for (std::set<std::pair<Pii*, LIROperand*>>::iterator j_iter = common_active.begin(); j_iter != common_active.end();) {
        Pii* pii_ptr = j_iter->first;
        if (pii_ptr->second > now_interval->first) {
            break;
        } else {
            LIROperand* temp_var = j_iter->second;
            int reg_num = assignReg[temp_var];
            common_phys_regs[reg_num]=1;
            j_iter = common_active.erase(j_iter);
            num++;
            final_result_[pii_ptr] = reg_num;
        }
    }
}
void Register::assginFreeReg(std::set<std::pair<Pii *, LIROperand *>, OpPtr> &common_active,
                             std::unordered_map<int, int> &common_phys_regs, unsigned int &free_reg_num, Pii* now_interval, bool isf) {
    LIROperand* now_opnd = interval_belong_umap[now_interval];
    if(free_reg_num > 0){
        if(!isf){
            for(int i=TOP_LIMIT_PHYS_REG; i>=1; --i){
                if(common_phys_regs[i]!=1 || isConflict(now_interval,i))
                    continue;
                else{
                    free_reg_num--;
                    assignReg[now_opnd] = i;
                    common_phys_regs[i]=-1;
                    common_active.emplace(now_interval, now_opnd);
                    return;
                }
            }
        }else{
            for(int i=BOTTOM_LIMIT_PHYS_FREG; i<=-1; ++i){
                if(common_phys_regs[i]!=1 || isConflict(now_interval,i))
                    continue;
                else{
                    free_reg_num--;
                    assignReg[now_opnd] = i;
                    common_phys_regs[i]=-1;
                    common_active.emplace(now_interval, now_opnd);
                    return;
                }
            }
        }
    }
    auto spill_iter = common_active.end();
    Pii* spill_itv = (--spill_iter)->first;
    if (spill_itv->second > now_interval->second) {
        LIROperand* spill_var = spill_iter->second;
        assignReg[now_opnd] = assignReg[spill_var];
        assignReg[spill_var] = REGALLOC_SPILL;
        final_result_[spill_itv] = REGALLOC_SPILL;
        common_active.erase(spill_iter);
        common_active.emplace(now_interval, now_opnd);
    } else {
        assignReg[now_opnd] = REGALLOC_SPILL;
        final_result_[now_interval] = REGALLOC_SPILL;
    }
}
bool Register::isConflict(Pii *now_interval, int rid) {
    std::list<Pii> &token_intervals = intervals_token_phys_reg[rid];
    if(token_intervals.empty()) return false;
    auto it = std::lower_bound(token_intervals.begin(),token_intervals.end(),*now_interval);
    if(it!=token_intervals.end()) {
        if( it->first < now_interval->second)
            return true;
        if( it->first==it->second && (it->first <= now_interval->second && it->first >= now_interval->first) )
            return true;
    }
    if(it!=token_intervals.begin()){
        it--;
        if(it->second > now_interval->first){
            return true;
        }
        if( it->first==it->second && (it->first <= now_interval->second && it->first >= now_interval->first) )
            return true;
        it++;
    }
    return false;
}
void Register::findRetBB(LIRBasicBlock* bb){
    if( !retBB ){
        if(bb->name_.size()>3 && "ret"==bb->name_.substr(bb->name_.size()-3,3)){
            retBB = bb;
        }
    }
}
bool Register::isRelevant(LIROperand* opnd,LIRInstruction* inst){
    if(inst->result_ && inst->result_ == opnd){
        return true;
    }else {
        for(LIROperand* lirop:inst->operands_){
            if(lirop == opnd){
                return true;
            }
        }
        return false;
    }
}
void Register::process_code() {
    lirf_->temps_offset_.push_back(lirf_->allocas_offset_end_);
    lirf_->temps_offset_.push_back(lirf_->allocas_offset_end_ + 4);
    lirf_->temps_offset_.push_back(lirf_->allocas_offset_end_ + 8);
    lirf_->temps_offset_.push_back(lirf_->allocas_offset_end_ + 12);
    lirf_->temps_offset_.push_back(lirf_->allocas_offset_end_ + 16);
    lirf_->temps_offset_.push_back(lirf_->allocas_offset_end_ + 20);
    lirf_->temps_offset_end_ = lirf_->allocas_offset_end_ + 24;
    int spills_offset_cur = lirf_->temps_offset_end_;
    for (LIRBasicBlock* lirbb : lirf_->basic_blocks_) {
        std::map<LIRInstruction*, std::pair<std::list<LIRInstruction*>, std::list<LIRInstruction*>>> addinst_map;
        for (LIRInstruction* lirinst : lirbb->instr_list_) {
            std::list<LIRInstruction*> addbefore;
            std::list<LIRInstruction*> addafter;
            std::map<int, int> useStatus;
            for (int i = 0; i < lirinst->num_ops_; i++) {
                LIROperand* lirop = lirinst->get_operand(i);
                if (lirop->tid_ == LIROperand::LOVirtRegTy) {
                    int assignedReg = getReg(lirop,lirinst);
                    if (assignedReg != REGALLOC_SPILL) {
                        lirinst->remove_operand(i);
                        lirinst->set_operand(i, lirm_->get_LIRPhysReg(assignedReg));
                        useStatus[assignedReg] = 1;
                    } else {
                        if (!lirf_->spills_offset_.count(lirop)) {
                            lirf_->spills_offset_[lirop] = spills_offset_cur;
                            spills_offset_cur += 4;
                        }
                    }
                } else if (lirop->tid_ == LIROperand::LOVirtFRegTy) {
                    int assignedReg = getReg(lirop,lirinst);
                    if (assignedReg != REGALLOC_SPILL) {
                        lirinst->remove_operand(i);
                        lirinst->set_operand(i, lirm_->get_LIRPhysFReg(assignedReg));
                        useStatus[assignedReg] = 1;
                    } else {
                        if (!lirf_->spills_offset_.count(lirop)) {
                            lirf_->spills_offset_[lirop] = spills_offset_cur;
                            spills_offset_cur += 4;
                        }
                    }
                } else if (lirop->tid_ == LIROperand::LOPhysRegTy) {
                    auto pr = dynamic_cast<LIRPhysReg*>(lirop);
                    useStatus[pr->rid_] = 1;
                } else if (lirop->tid_ == LIROperand::LOPhysFRegTy) {
                    auto pfr = dynamic_cast<LIRPhysFReg*>(lirop);
                    useStatus[pfr->frid_] = 1;
                }
            }
            if(LIROperand* lirinst_result = lirinst->result_) {
                if (lirinst_result->tid_ == LIROperand::LOVirtRegTy) {
                    int assignedReg = getReg(lirinst_result,lirinst);
                    if (assignedReg != REGALLOC_SPILL) {
                        lirinst->remove_result();
                        lirinst->set_result(lirm_->get_LIRPhysReg(assignedReg));
                        useStatus[assignedReg] = 1;
                    } else {
                        if (!lirf_->spills_offset_.count(lirinst_result)) {
                            lirf_->spills_offset_[lirinst_result] = spills_offset_cur;
                            spills_offset_cur += 4;
                        }
                    }
                } else if (lirinst_result->tid_ == LIROperand::LOVirtFRegTy) {
                    int assignedReg = getReg(lirinst_result,lirinst);
                    if (assignedReg != REGALLOC_SPILL) {
                        lirinst->remove_result();
                        lirinst->set_result(lirm_->get_LIRPhysFReg(assignedReg));
                        useStatus[assignedReg] = 1;
                    } else {
                        if (!lirf_->spills_offset_.count(lirinst_result)) {
                            lirf_->spills_offset_[lirinst_result] = spills_offset_cur;
                            spills_offset_cur += 4;
                        }
                    }
                } else if (lirinst_result->tid_ == LIROperand::LOPhysRegTy) {
                    auto pr = dynamic_cast<LIRPhysReg*>(lirinst_result);
                    useStatus[pr->rid_] = 1;
                } else if (lirinst_result->tid_ == LIROperand::LOPhysFRegTy) {
                    auto pfr = dynamic_cast<LIRPhysFReg*>(lirinst_result);
                    useStatus[pfr->frid_] = 1;
                }
            }
            for (int i = 0; i < lirinst->num_ops_; i++) {
                LIROperand* lirop = lirinst->get_operand(i);
                if (lirop->tid_ == LIROperand::LOVirtRegTy) {
                   
                    int j = 5;
                    for (; j <= 12; j++) {
                        if (!useStatus.count(j))
                            break;
                    }
                    lirinst->remove_operand(i);
                    lirinst->set_operand(i, lirm_->get_LIRPhysReg(j));
                    addbefore.push_back(new LIRLdrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysReg(j), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(lirf_->spills_offset_.at(lirop)), LIRInstruction::LRegisterOffsetTy));
                    useStatus[j] = 2;
                } else if (lirop->tid_ == LIROperand::LOVirtFRegTy) {
                  
                    int j = -17;
                    for (; j >= -31; j--) {
                        if (!useStatus.count(j))
                            break;
                    }
                    lirinst->remove_operand(i);
                    lirinst->set_operand(i, lirm_->get_LIRPhysFReg(j));
                    addbefore.push_back(new LIRVldrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysFReg(j), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(lirf_->spills_offset_.at(lirop))));
                    useStatus[j] = 2;
                }
            }
            if(LIROperand* lirinst_result = lirinst->result_){
                if (lirinst_result->tid_ == LIROperand::LOVirtRegTy) {
                    
                    int j = 5;
                    for (; j <= 12; j++) {
                        if (!useStatus.count(j))
                            break;
                    }
                    lirinst->remove_result();
                    lirinst->set_result(lirm_->get_LIRPhysReg(j));
                    addafter.push_back(new LIRStrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysReg(j), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(lirf_->spills_offset_.at(lirinst_result)), LIRInstruction::LRegisterOffsetTy));
                    useStatus[j] = 2;
                } else if (lirinst_result->tid_ == LIROperand::LOVirtFRegTy) {
                  
                    int j = -17;
                    for (; j >= -31; j--) {
                        if (!useStatus.count(j))
                            break;
                    }
                    lirinst->remove_result();
                    lirinst->set_result(lirm_->get_LIRPhysFReg(j));
                    addafter.push_back(new LIRVstrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysFReg(j), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(lirf_->spills_offset_.at(lirinst_result))));
                    useStatus[j] = 2;
                }
            }
            int j = 0;
            for (int i = 1; i <= 12; i++) {
                if (useStatus.count(i) && useStatus.at(i) == 2) {
                    int tmpoffset = lirf_->temps_offset_[j];
                    addbefore.push_front(new LIRStrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysReg(i), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(tmpoffset), LIRInstruction::LRegisterOffsetTy));
                    addafter.push_back(new LIRLdrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysReg(i), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(tmpoffset), LIRInstruction::LRegisterOffsetTy));
                    j += 1;
                }
            }
            for (int i = -1; i >= -32; i--) {
                if (useStatus.count(i) && useStatus.at(i) == 2) {
                    int tmpoffset = lirf_->temps_offset_[j];
                    addbefore.push_front(new LIRVstrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysFReg(i), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(tmpoffset)));
                    addafter.push_back(new LIRVldrInst(LIRInstruction::LCondNone, lirm_->get_LIRPhysFReg(i), lirm_->get_LIRPhysReg(14), lirm_->get_LIRConstant(tmpoffset)));
                    j += 1;
                }
            }
            addinst_map[lirinst]={addbefore,addafter};
        }
        for (const auto& pair: addinst_map) {
            for (auto inst: pair.second.first) {
                lirbb->add_inst_before(inst,pair.first);
            }
            for (auto inst = pair.second.second.rbegin(); inst != pair.second.second.rend(); ++inst) {
                lirbb->add_inst_after(*inst,pair.first);
            }
        }
    }
    lirf_->spills_offset_end_=spills_offset_cur;
    if(lirf_->spills_offset_end_==lirf_->temps_offset_end_){
        lirf_->temps_offset_end_=lirf_->allocas_offset_end_;
        lirf_->spills_offset_end_=lirf_->allocas_offset_end_;
    }
}
int Register::is_KF_hasR_noUse(LIRInstruction* inst){
   
    LIRBlInst* blinst = static_cast<LIRBlInst*>(inst);
    LIRFunction* calllirf = static_cast<LIRFunction*>(blinst->get_operand(0));
    if(calllirf->has_result_!=0&&blinst->result_unused_){
        if(calllirf->has_result_==1){
            return 1;
        }else{
            assert(calllirf->has_result_==2);
            return -1;
        }
    }
    return 0;
}
