#ifndef SCOPE_H
#define SCOPE_H

#include "llvm.h"

class Scope;
class Scope {
public:
    
std::vector<std::map<std::string, Value *>> symbol;
  void enter() { symbol.push_back({}); }

  void exit() { symbol.pop_back(); }

  bool in_global() { return symbol.size() == 1; }

  
  bool push(std::string name, Value *val) {
    bool result;
    result = (symbol[symbol.size() - 1].insert({name, val})).second;
    return result;
  }

  Value *find(std::string name) {
    for (auto s = symbol.rbegin(); s != symbol.rend(); s++) {
      auto iter = s->find(name);
      if (iter != s->end()) {
        return iter->second;
      }
    }
    return nullptr;
  }
};
#endif